function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useEffect, useState } from 'react';
import '../styles/join.less';
import _ from 'lodash';
import TableColumnSelector from './TableColumnSelector';
import useNode from './useNode';
import JoinConditionPanel from './joinConditionPanel';
import { notification } from 'antd';
var timer;
var FlowJoinConfig = function FlowJoinConfig(props) {
  var _nodeData$resultTable, _nodeData$resultTable2, _node$getData, _node$getData$resultT;
  var node = props.node;
  var _useNode = useNode(node),
    tableList = _useNode.tableList,
    loading = _useNode.loading;
  var nodeData = node.getData();
  var _useState = useState((nodeData === null || nodeData === void 0 ? void 0 : (_nodeData$resultTable = nodeData.resultTable) === null || _nodeData$resultTable === void 0 ? void 0 : _nodeData$resultTable.table1) || []),
    _useState2 = _slicedToArray(_useState, 2),
    selectedA = _useState2[0],
    setSelectedA = _useState2[1];
  var _useState3 = useState([]),
    _useState4 = _slicedToArray(_useState3, 2),
    comapreTableA = _useState4[0],
    setCompareTableA = _useState4[1];
  var _useState5 = useState([]),
    _useState6 = _slicedToArray(_useState5, 2),
    comapreTableB = _useState6[0],
    setCompareTableB = _useState6[1];
  var _useState7 = useState((nodeData === null || nodeData === void 0 ? void 0 : (_nodeData$resultTable2 = nodeData.resultTable) === null || _nodeData$resultTable2 === void 0 ? void 0 : _nodeData$resultTable2.table2) || []),
    _useState8 = _slicedToArray(_useState7, 2),
    selectedB = _useState8[0],
    setSelectedB = _useState8[1];
  var _tableList = _slicedToArray(tableList, 2),
    tableA = _tableList[0],
    tableB = _tableList[1];
  var _useState9 = useState(nodeData),
    _useState10 = _slicedToArray(_useState9, 2),
    data = _useState10[0],
    setData = _useState10[1];
  var classPrefix = 'flow-join-config';
  useEffect(function () {
    if (!data || loading) return;
    updateData();
  }, [data, selectedA, selectedB, loading]);
  function updateData() {
    if (timer) clearTimeout(timer);
    timer = setTimeout(function () {
      var _data$joinOn;
      var nameMap = {};
      var nameInvalid = false;
      selectedA.concat(selectedB).forEach(function (item) {
        if (!nameMap[item.modifyName || item.origin.name]) {
          nameMap[item.modifyName || item.origin.name] = true;
        } else {
          nameInvalid = true;
          notification.warning({
            message: "\u5B58\u5728\u91CD\u540D\u5B57\u6BB5: ".concat(item.modifyName || item.origin.name)
          });
        }
      });
      node.updateData(_objectSpread(_objectSpread({}, data), {}, {
        status: nameInvalid || !((_data$joinOn = data.joinOn) === null || _data$joinOn === void 0 ? void 0 : _data$joinOn.length) || !selectedA.length && !selectedB.length ? 'failed' : 'success',
        resultTable: {
          table1: selectedA,
          table2: selectedB
        }
      }));
    }, 200);
  }
  function onChangeCondition(val) {
    setData(function (data) {
      var res = _.cloneDeep(data) || {};
      return _objectSpread(_objectSpread({}, res), val);
    });
  }
  return /*#__PURE__*/React.createElement("div", {
    className: classPrefix
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-left")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-title")
  }, "\u5173\u8054\u65B9\u5F0F"), /*#__PURE__*/React.createElement(JoinConditionPanel, {
    defaultValue: node.getData(),
    loading: loading,
    tableA: tableA,
    tableB: tableB,
    onChange: onChangeCondition
  })), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-right")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-title")
  }, "\u4FDD\u7559\u5B57\u6BB5", /*#__PURE__*/React.createElement("span", null, "\u5BF9\u91CD\u590D\u5B57\u6BB5\u9700\u8FDB\u884C\u91CD\u65B0\u547D\u540D")), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-tables")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-table")
  }, /*#__PURE__*/React.createElement(TableColumnSelector, {
    loading: loading,
    table: tableA,
    title: "\u6570\u636E\u96C6: ".concat((tableA === null || tableA === void 0 ? void 0 : tableA.name) || '-'),
    validatorScope: comapreTableB,
    defaultValue: selectedA,
    onChange: setSelectedA,
    onChangeAll: setCompareTableA,
    simpleMode: true
  })), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-table")
  }, /*#__PURE__*/React.createElement(TableColumnSelector, {
    loading: loading,
    table: tableB,
    title: "\u6570\u636E\u96C6: ".concat((tableB === null || tableB === void 0 ? void 0 : tableB.name) || '-'),
    defaultValue: (_node$getData = node.getData()) === null || _node$getData === void 0 ? void 0 : (_node$getData$resultT = _node$getData.resultTable) === null || _node$getData$resultT === void 0 ? void 0 : _node$getData$resultT.table2,
    onChange: setSelectedB,
    simpleMode: true,
    compareTable: tableA,
    validatorScope: comapreTableA,
    onChangeAll: setCompareTableB
  })))));
};
export default FlowJoinConfig;